package gui;

import java.awt.*;

import javax.swing.*;

import java.util.*;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JLabel;

import mst.Edge;
import mst.Graph;
import mst.InterfaceMST;
import mst.Point;
import mst.SpanningTree;

import java.awt.Dimension;
import javax.swing.JCheckBox;
import java.awt.BorderLayout;

public class MinimumSTApplet extends JApplet {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JButton jButtonStart = null;
	private DrawPanel drawPanel = null;
	private JPanel controlPanel = null;
	private JSlider jSlider = null;
	private JLabel jLabelMaximum = null;
	private JPanel jBottomPanel = null;
	//private JButton jButtonLoad = null;
	private JCheckBox jCheckBoxPrintCoordinate = null;
	//private JButton jButtonSave = null;
	private JLabel jLabelPointNum = null;
	private InterfaceMST spanningTree = new SpanningTree();
	private int maxCount;
	private boolean isManual = false;
	private Font font=new Font("",Font.PLAIN,12);
	private Graph graph = null;
	/**
	 * This is the default constructor
	 */
	public MinimumSTApplet() {
		super();
		setVisible(true);
		Collection<Point> temp = new HashSet<Point>();
		temp.add(new Point(1, 1));
		temp.add(new Point(1, 2));
		temp.add(new Point(2, 1));
		// graphics=drawPanel.getGraphics();
		// AbstractConvexHull.setGraphics(graphics);
		getDrawPanel().clearRect();
		clearDrawPanel();

	}

	/*
	 * public void update(Graphics g) { paint(g); }
	 */
	public void clearDrawPanel() {
		getDrawPanel().clearRect();
	}


	/**
	 * This method initializes jCheckBoxPrintCoordinate
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBoxPrintCoordinate() {
		if (jCheckBoxPrintCoordinate == null) {
			jCheckBoxPrintCoordinate = new JCheckBox();
			jCheckBoxPrintCoordinate.setText("ǥ ǥ");
			jCheckBoxPrintCoordinate.setFont(font);
		}
		return jCheckBoxPrintCoordinate;
	}

	public static void main(String args[]) {
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (UnsupportedLookAndFeelException e) {
			e.printStackTrace();
		}
		new MinimumSTApplet();
	}

	/**
	 * This method initializes jBottomPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJBottomPanel() {
		if (jBottomPanel == null) {
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints.gridy = -1;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.gridx = -1;
			jBottomPanel = new JPanel();
			jBottomPanel.setLayout(new BorderLayout());
			jBottomPanel.add(getControlPanel(), BorderLayout.NORTH);
		}
		return jBottomPanel;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public void init() {
		this.setSize(710, 646);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getDrawPanel(), BorderLayout.CENTER);
			jContentPane.add(getJBottomPanel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes controlPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getControlPanel() {
		if (controlPanel == null) {

			jLabelTimer = new JLabel();
			jLabelTimer.setText(" ");
			jLabelTimer.setFont(font);
			jLabelPointNum = new JLabel();
			jLabelPointNum.setText(" ");
			jLabelPointNum.setFont(font);
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
			flowLayout.setHgap(5);
			controlPanel = new JPanel();
			controlPanel.setLayout(flowLayout);
			controlPanel.add(jLabelTimer, null);
			controlPanel.add(jLabelPointNum, null);
			controlPanel.add(getJSlider(), null);
			controlPanel.add(getJLabel(), null);
			controlPanel.add(getJCheckBoxPrintCoordinate(), null);
			controlPanel.add(getJButtonStart(), null);
		}
		return controlPanel;
	}

	/**
	 * This method initializes drawPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private DrawPanel getDrawPanel() {
		if (drawPanel == null) {
			drawPanel = new DrawPanel();
			drawPanel.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					if (!isManual) {
						isManual = true;
						graph = new Graph();
						getDrawPanel().clearRect();
						getDrawPanel().setGabs(0, 0);
					}
					getDrawPanel().drawPoint(e.getPoint());
					graph.add(new Point(e.getPoint().x, e.getPoint().y));
					getJButtonStart().setText(graph.getPoints().size() + ":");

				}
			});
			drawPanel.setPreferredSize(new Dimension(600, 600));
		}
		return drawPanel;
	}


	/**
	 * This method initializes jButtonStart
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonStart() {
		if (jButtonStart == null) {
			jButtonStart = new JButton();
			jButtonStart.setFont(font);
			jButtonStart.setText("ڵ");
			jButtonStart.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (!isManual) {
						int size = getJSlider().getValue();
						if (size > maxCount) {
							int sel = JOptionPane.showConfirmDialog(getDrawPanel(), " ʹ Ƽ   ʽϴ.\nϽðڽϱ?", "",
									JOptionPane.OK_CANCEL_OPTION);
							if (sel != JOptionPane.OK_OPTION) {
								return;
							}
						}
						getDrawPanel().setGabs(20, 20);
						graph = new Graph();
						time = System.currentTimeMillis();
						int w = getDrawPanel().getWidth() - 40;
						int h = getDrawPanel().getHeight() - 40;
						Random rand = new Random(System.currentTimeMillis());
						for (int i = 0; i < size; i++) {
							graph.add(new mst.Point(rand.nextInt(w), rand.nextInt(h)));
						}
						getDrawPanel().setDefaultRate();
						jLabelTimer.setText("start");
						run(graph);
					} else {
						time = System.currentTimeMillis();
						isManual = false;
						getDrawPanel().setGabs(0, 0);
						getJButtonStart().setText("ڵ");
						run(graph);
					}

				}
			});
		}
		return jButtonStart;
	}

	private long time;
	private JLabel jLabelTimer = null;
	private void run(Graph graph) {
		getJButtonStart().setEnabled(false);
		jLabelTimer.setText("ready : " + ((System.currentTimeMillis() - time) / 1000.0) + " s");
		getDrawPanel().setCordinatePrintable(getJCheckBoxPrintCoordinate().isSelected());
		getDrawPanel().clearRect();
		Collection<mst.Point> points = graph.getPoints();
		getDrawPanel().drawPoints(points);
		List<Edge> edges = spanningTree.makeMST(graph);
		getDrawPanel().drawLines(edges);
		jLabelTimer.setText("complete : " + ((System.currentTimeMillis() - time) / 1000.0) + " s");

		getJButtonStart().setEnabled(true);
	}

	private JLabel getJLabel() {
		if (jLabelMaximum == null) {
			jLabelMaximum = new JLabel();
			jLabelMaximum.setText("50");
			jLabelMaximum.setPreferredSize(new Dimension(50, 15));
			jLabelMaximum.setFont(font);
		}
		return jLabelMaximum;

	}

	/**
	 * This method initializes jSlider
	 * 
	 * @return javax.swing.JSlider
	 */
	private JSlider getJSlider() {
		if (jSlider == null) {
			jSlider = new JSlider();

			long maxmem = Runtime.getRuntime().maxMemory();
			maxCount=(int)Math.sqrt(maxmem/2.0);
			System.out.println("maxmem=" + maxmem + "byte" +", maxcount="+maxCount);
			jSlider.setMaximum(maxCount);
			jSlider.setPreferredSize(new Dimension(200, 23));
			jSlider.setValue(50);
			jSlider.setMinimum(3);
			jSlider.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					getJLabel().setText(getPointNumber() + "");
				}
			});
		}
		return jSlider;
	}

	public int getPointNumber() {
		return getJSlider().getValue();
	}

	public void paint(Graphics g) {
		super.paint(g);
		getDrawPanel().paint(g);
	}

} //  @jve:decl-index=0:visual-constraint="45,-26"
