package mst;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class CopyOfGraph {
	ArrayList<ArrayList<Point>> graph;
	Set<Point> points;
	//ArrayList<Point> points;
	MinHeap<Edge> heap;
	private boolean isDisable = false;

	public CopyOfGraph() {
		// TODO Auto-generated constructor stub
		graph = new ArrayList<ArrayList<Point>>();
		points = new HashSet<Point>();

	}

	public void add(Point p) {
		if (isDisable) {
			System.out.println("߸ ");
			return;
		}

		if (!points.contains(p)) {
			p.setIndex(graph.size());
			points.add(p);
			graph.add(new ArrayList<Point>());
			for (List<Point> list : graph) {
				list.add(p);
			}
		}

	}

	public void end() {
		isDisable = true;
		heap = new MinHeap<Edge>(graph.size());
		graph.remove(graph.size() - 1);
		int cpus = Runtime.getRuntime().availableProcessors();
		//System.out.println(cpus);
		if (cpus > 1 && graph.size() > 2000) {
			@SuppressWarnings("unchecked")
			List<ArrayList<Point>> lista[] = new List[cpus];
			for (int i = 0; i < cpus; i++) {
				lista[i] = new ArrayList<ArrayList<Point>>();
			}

			for (int i = 0; i < graph.size(); i++) {

				lista[i % cpus].add(graph.get(i));

			}
			for (int i = 0; i < cpus; i++) {
				new Thr(lista[i]).start();
			}
		} else {
			new Thr(graph).run();
		}
		//System.out.println(graph.size());

		while (heap.size != graph.size()) {
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	class Thr extends Thread {
		List<ArrayList<Point>> graph;

		public Thr(List<ArrayList<Point>> graph) {
			// TODO Auto-generated constructor stub
			this.graph = graph;
		}

		@Override
		public void run() {
			// TODO Auto-generated method stub
			for (ArrayList<Point> list : graph) {
				int size = list.size() - 1;
				Collections.sort(list, new PointComparator(list.get(0)));
				heap.insert(new Edge(list.get(size), list.get(size - 1)));
			}
		}
	}

	public Edge getMinEdge() {
		//List<Edge> a=new ArrayList<Edge>();
		// ߿ ּ ġ
		Edge edge = heap.ExtractMin();
		// .
		Point p1 = edge.getP1();
		//   List
		List<Point> temp = graph.get(p1.index);
		//  List ι°. ù° 
		int size = temp.size() - 2;
		if (temp.size() > 2) {
			temp.remove(size);
			heap.insert(new Edge(temp.get(size), temp.get(size - 1)));
		}

		return edge;
	}

	public Collection<Point> getPoints() {
		return points;
	}

	class PointComparator implements Comparator<Point> {
		Point pibot;

		public PointComparator(Point p) {
			// TODO Auto-generated constructor stub
			pibot = p;
		}

		public void setPibot(Point pibot) {
			this.pibot = pibot;
		}

		@Override
		public int compare(Point o1, Point o2) {
			// TODO Auto-generated method stub
			Long r1 = Point.distance(pibot, o1);
			Long r2 = Point.distance(pibot, o2);
			return r2.compareTo(r1);
		}
	}

	class MinHeap<T extends Comparable<T>> {

		private T[] heap = null;
		private int size = 0;

		@SuppressWarnings("unchecked")
		public MinHeap() {
			heap = (T[]) new Comparable[1024];
		}

		@SuppressWarnings("unchecked")
		public MinHeap(int size) {
			heap = (T[]) new Comparable[size];
		}

		public boolean isEmpty() {
			return size == 0;
		}

		public synchronized void insert(T element) {
			if (size >= heap.length) {
				T[] temp = Arrays.copyOf(heap, heap.length * 2);
				heap = temp;
			}
			heap[size] = element;
			int i = size;
			int p = getParent(i);
			while (p >= 0 && heap[p].compareTo(heap[i]) > 0) {
				T temp = heap[i];
				heap[i] = heap[p];
				heap[p] = temp;
				i = p;
				p = getParent(p);
			}
			size++;
		}

		public T getMinimun() {
			return heap[0];
		}

		public T ExtractMin() {
			T min = heap[0];
			size--;
			heap[0] = heap[size];
			heapify(0);
			return min;
		}

		private void heapify(int i) {
			if (!hasChild(i))
				return;
			int k = getMinimumChild(i);
			if (heap[i].compareTo(heap[k]) > 0) {
				T temp = heap[i];
				heap[i] = heap[k];
				heap[k] = temp;
				heapify(k);
			}
		}

		private boolean hasChild(int i) {
			return (i * 2 + 1) < size;
		}

		private int getParent(int i) {
			return (i - 1) / 2;
		}

		private int getMinimumChild(int i) {
			if ((i * 2 + 2) < size) {
				return heap[i * 2 + 1].compareTo(heap[i * 2 + 2]) < 0 ? i * 2 + 1 : i * 2 + 2;
			} else if (i * 2 + 1 < size) {
				return i * 2 + 1;
			} else {
				return -1;
			}
		}

		public String toString() {
			String str = "";
			for (int i = 0; i < size; i++) {
				str += i + " : " + heap[i] + "\n";
			}
			return str;
		}
	}
	
	

}

