package mst;

import java.util.ArrayList;
import java.util.List;


public class SpanningTree implements InterfaceMST{
	private ArrayList<Integer> parent = null;
	private List<Point> points = null;
	private ArrayList<Edge> result=null;


	/**
	 * 
	 * @return
	 */
	public List<Edge> makeMST(Graph graph)
	{
		parent=new ArrayList<Integer>();
		points=new ArrayList<Point>();
		result = new ArrayList<Edge>();
		graph.end();
		
		int num=graph.getPoints().size();
		for(int i=0;i<=num;i++){
			parent.add(i);
		}
		
		num-=1;
		Edge edge;
		while(result.size()< num) {
			edge=graph.getMinEdge();
			int a = edge.getP1().getIndex();
			int b = edge.getP2().getIndex();
			if (findSet(a) != findSet(b)) {
				union(a, b);
				result.add(edge);
			}
		}
		
		return result;
	}

	@Override
	public List<Edge> getMST() {
		// TODO Auto-generated method stub
		return result;
	}
	private int findSet(int i) {
		if (i != parent.get(i)) {
			int p = findSet(parent.get(i));
			parent.set(i, p);
		}
		return parent.get(i);
	}

	private void union(int a, int b) {
		parent.set(findSet(a), parent.get(b));
	}

	public List<Point> getPoints() {
		// TODO Auto-generated method stub
		return points;
	}
}
